const mix = require('laravel-mix')
const path = require('path')
const fs = require('fs')

require('laravel-mix-purgecss')

/*
 |--------------------------------------------------------------------------
 | Mix Asset Management
 |--------------------------------------------------------------------------
 |
 | Mix provides a clean, fluent API for defining some Webpack build steps
 | for your Laravel application. By default, we are compiling the Sass
 | file for your application, as well as bundling up your JS files.
 |
 */

mix
    .options({
        terser: {
            extractComments: false,
        },
        processCssUrls: false
    })
    .setPublicPath('./public')
    .sass('styles.scss', 'public/styles.css')
    .purgeCss({
        extend: {
            content: [
                path.join(__dirname, 'public/*.html'),
            ]
        }
    })
    .version()
